/*
yQ[ez
GiꂽjɃZOgîj𓊂ē|Q[B

yQ[̎nߕz
dIŃ^CgʁuSEG.ATTACKvB
XCb`IŃQ[JnB
XCb`ŃnCXRAʂցB

yQ[̑@z
A|G̐AeijAGifГIȐ̌`jB
XCb`IF		𓊂B
XCb`F	Q[~B

yQ[̗Vѕz
vC[邩iej_ŕ\B
炪GɓāA猂jBڈƂāu.vtAGA̓GB
G̕\i\ĂZOgjɂ炪A̕\͏B
܂A莞Ԃo߂ƂƂɓG̓vC[ɋߕtĂB
vC[̈ʒu܂œGQ[I[o[BXCb`IŃXRAʂցB
XRAʂXCb`IŃ^CgʂցB
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include "vfdctrl.h"
#include "segment.h"
#include "button.h"


//Q[̏
typedef	enum
{
	ST_TITLE,
	ST_READY,
	ST_PLAY,
	ST_SHOT,
	ST_COMPLETE,
	ST_GAMEOVER,
	ST_SCORE,
	ST_NONE
}
EStatus;

#define	BULLET_KEEP_DEFAULT	(1500 / 60)	//1.5bi60msPʁj	eω鎞ԊԊuFJnl
#define	BULLET_KEEP_FASTEST	(700 / 60)	//0.7bi60msPʁj	eω鎞ԊԊuFől
#define	ENEMY_MOVEWAIT_PARAM	4		//Gړ鎞ԊԊu߂p[^
#define	ENEMY_MOVEWAIT_DEFAULT	(BULLET_KEEP_DEFAULT * ENEMY_MOVEWAIT_PARAM)	//Gړ鎞ԊԊuie̕ωԂ̔{ŕωj
#define	SCORE_MAX	999		//XRA̍ől
#define	SPEEDUP_STEP	3	//G̓|Q[Xs[hAbv邩

//VFD̃Obhʒu
#define GRIDPOS_COMPLETE_TOTAL	1
#define GRIDPOS_SCORE	1
#define GRIDPOS_BULLET	4
#define GRIDPOS_ENEMY	9

//ϐ
static	EButtonState btn;
static	EStatus	gameState;
static	uint8_t	isFirstLoop;
static	uint8_t	loopCount;
static	uint8_t	bullet, prevBullet, isCreateBullet, bulletPos, bulletKeepCount, bulletKeepMax;
static	uint8_t	enemy, isCreateEnemy, enemyPos, enemyMoveWaitCount, enemyMoveWaitMax;
static	uint8_t	completeTotal;
static	uint8_t	effectWait;
static	uint16_t	score, hiscore;

//̎`̔z
static	uint8_t	SegNums[10];

//֐
static	void	GameTitle(EButtonState btn);
static	void	GameReady(EButtonState btn);
static	void	GamePlay(EButtonState btn);
static	void	GameShot(EButtonState btn);
static	void	GameComplete(EButtonState btn);
static	void	GameGameOver(EButtonState btn);
static	void	GameScore(EButtonState btn);
static	void	ValueSplit(uint8_t n, uint8_t* buf);

//
static	uint16_t	_random = 1;

//16bit^srand()
static	void	srand(uint16_t seed)
{
	_random = seed;
}

//16bit^rand()
static	uint16_t	rand(void)
{
	_random = _random * 11035 + 12345;
	return (_random ^ 15245);
}

//^C}[JE^[荞
volatile	static	uint8_t	tci = 0;

//I[o[t[荞
ISR(TIMER0_OVF_vect)
{
	tci = 1;
}

//Q[W[
void	GAME_Init(void)
{
	//SegNums[]̏
	SegNums[0] = SegC_0;	SegNums[1] = SegC_1;	SegNums[2] = SegC_2;	SegNums[3] = SegC_3;	SegNums[4] = SegC_4;
	SegNums[5] = SegC_5;	SegNums[6] = SegC_6;	SegNums[7] = SegC_7;	SegNums[8] = SegC_8;	SegNums[9] = SegC_9;
	
	gameState = ST_TITLE;
	isFirstLoop = 1;
	
	loopCount = 0;
	hiscore = 0;
}

//Q[s
void	GAME_Exec(void)
{
	btn = (++loopCount == 0) ? Button_ButtonState() : ButtonRelease;
	
	EStatus	prevState = gameState;
	switch (gameState)
	{
	case ST_TITLE:		GameTitle(btn);		break;
	case ST_READY:		GameReady(btn);		break;
	case ST_PLAY:		GamePlay(btn);		break;
	case ST_SHOT:		GameShot(btn);		break;
	case ST_COMPLETE:	GameComplete(btn);	break;
	case ST_GAMEOVER:	GameGameOver(btn);	break;
	case ST_SCORE:		GameScore(btn);		break;
	default:	break;
	}
	
	isFirstLoop = (prevState != gameState);
}

//ST_TITLE
static	void	GameTitle(EButtonState btn)
{
	if (isFirstLoop)
	{
		//uSEG.ATTACKv
		uint8_t grid = 1;
		VFD_GridArray(grid++, SegC_S, SegM_null);
		VFD_GridArray(grid++, SegC_E, SegM_null);
		VFD_GridArray(grid++, SegC_G, SegM_dp);
		VFD_GridArray(grid++, SegC_A, SegM_null);
		VFD_GridArray(grid++, SegC_T, SegM_null);
		VFD_GridArray(grid++, SegC_T, SegM_null);
		VFD_GridArray(grid++, SegC_A, SegM_null);
		VFD_GridArray(grid++, SegC_C, SegM_null);
		VFD_GridArray(grid++, SegC_K, SegM_null);
	}
	
	if (btn == ButtonOff)
	{
		gameState = ST_READY;
	}
	
	if (btn == ButtonLongHold)
	{
		score = hiscore;
		gameState = ST_SCORE;
	}
}

//ST_READY
static	void	GameReady(EButtonState btn)
{
	srand(loopCount);
	VFD_Clear();
	
	isCreateBullet = 1;		//tO(1/0)
	isCreateEnemy = 1;		//tO(1/0)
	
	prevBullet = SegC_null;
	completeTotal = 0;
	score = 0;
	bulletKeepMax = BULLET_KEEP_DEFAULT;
	enemyMoveWaitMax = ENEMY_MOVEWAIT_DEFAULT;
	gameState = ST_PLAY;
	tci = 0;
	sei();		//荞݋
}

//ST_PLAY
static	void	GamePlay(EButtonState btn)
{
	if (isFirstLoop)
	{
		//|G̐\
		//Ee1}X󂯂̂3̂2\B
		uint8_t	grid = GRIDPOS_COMPLETE_TOTAL;
		uint8_t	buf[3];
		ValueSplit(completeTotal, buf);
		VFD_GridArray(grid++, buf[1], SegM_null);
		VFD_GridArray(grid++, buf[2], SegM_null);
	}
	
	//JPiej𐶐
	if (isCreateBullet)
	{
		isCreateBullet = 0;
		do { bullet = 1 << (rand() % 7); } while (prevBullet == bullet);	//Ǒ`ƓɂȂȂ悤ɂ
		prevBullet = bullet;	//񐶐`ۑĂ
		
		bulletPos = GRIDPOS_BULLET;
		VFD_GridArray(bulletPos, bullet, SegM_null);
		bulletKeepCount = 0;
	}
	
	//G𐶐
	if (isCreateEnemy)
	{
		isCreateEnemy = 0;
		enemy = 0x00;
		do
		{
			//KȊmŃZOg̗L߂B󔒕ɂȂȂ悤ɂ
			for (uint8_t i = 0; i < 7; i++) { enemy |= ((rand() % 100 < 30 ? 1 : 0) << i); }	
		}
		while (enemy == 0x00);
		
		enemyPos = GRIDPOS_ENEMY;
		VFD_GridArray(enemyPos, enemy, SegM_null);
		enemyMoveWaitCount = 0;
	}
	
	//
	if (btn == ButtonOff)
	{
		gameState = ST_SHOT;
		return;
	}
	
	//ŃQ[I
	if (btn == ButtonLongHold)
	{
		gameState = ST_GAMEOVER;
		return;
	}
	
	//[vJE^[
	if (tci)
	{
		tci = 0;
		
		//̎Ԃo߂JPiejύX
		if (++bulletKeepCount == bulletKeepMax)
		{
			isCreateBullet = 1;
		}
		
		//̎Ԃo߂Gړ
		if (++enemyMoveWaitCount == enemyMoveWaitMax)
		{
			enemyMoveWaitCount = 0;
			VFD_GridArray(enemyPos, SegC_null, SegM_null);
			enemyPos--;
			uint8_t segM = (enemy == SegC_null) ? SegM_apostrophe : SegM_null;
			VFD_GridArray(enemyPos, enemy, segM);
		}
		
		//ړGvC[ƏՓ˂ꍇ
		if (enemyPos == GRIDPOS_BULLET)
		{
			gameState = ST_GAMEOVER;
		}
	}
}

//eړ
//ST_SHOT
static	void	GameShot(EButtonState btn)
{
	if (tci)
	{
		tci = 0;
		VFD_GridArray(bulletPos, SegC_null, SegM_null);		//݈ʒu̒e
			
		if (bulletPos + 1 < enemyPos)
		{
			VFD_GridArray(++bulletPos, bullet, SegM_null);		//ei߂
		}
		else
		{
			//eGʒuɓB
			
			//GɃJPiejA͂߂^
			if (enemy & bullet) { enemy &= ~bullet; } else { enemy |= bullet; }
			uint8_t segM = (enemy == SegC_null) ? SegM_apostrophe : SegM_null;
			VFD_GridArray(enemyPos, enemy, segM);
			
			//`̔
			if (enemy == SegC_null)
			{
				//炸AăZOgS{[iX_l
				//EȂȂG܂ɋԂȂ̂ŁǍɉ炩̐`܂œ|ƂɂȂȂB
				score += 20;
			}
			else
			{
				//0`9`ꂽ肷
				for (uint8_t i = 0; i <= 9; i++)
				{
					if (enemy == SegNums[i])
					{
						VFD_GridArray(enemyPos, enemy, SegM_dp);	//GʒuDP_
						gameState = ST_COMPLETE;
						break;
					}
				}
			}
			
			//`łĂȂȂvCs
			if (gameState != ST_COMPLETE)
			{
				gameState = ST_PLAY;
				isCreateBullet = 1;		//Ɏ̒e𐶐iȂƁAeAȂԂ̂܂܉񂩌ĂĂ܂j
			}
		}
	}
}

//ST_COMPLETEi``ꂽj
static	void	GameComplete(EButtonState btn)
{
	if (isFirstLoop)
	{
		//XRAvZ
		//EZOǧ𐔂B
		uint8_t bitCount = 0;
		for (uint8_t bits = enemy, i = 0; i < 7; i++, bits >>= 1) { bitCount += (bits & 0x01); }
		score += (bitCount + (enemyPos - GRIDPOS_BULLET));
		if (SCORE_MAX < score) { score = SCORE_MAX; }
		
		//Q[Xs[h
		//EG萔|ƂɁAe̕ωԊuZȂB
		//EɘAēG̈ړC^[oZȂB
		if (++completeTotal % SPEEDUP_STEP == 0)
		{
			if (BULLET_KEEP_FASTEST < bulletKeepMax)
			{
				bulletKeepMax--;
				enemyMoveWaitMax = bulletKeepMax * ENEMY_MOVEWAIT_PARAM;
			}
		}
		
		effectWait = 0;
	}
	
	//莞ԑ҂
	if (tci)
	{
		tci = 0;
		
		//60msԊu16JEg1bo
		if (++effectWait == 16)
		{
			VFD_GridArray(enemyPos, SegC_null, SegM_null);
			isCreateBullet = 1;
			isCreateEnemy = 1;
			gameState = ST_PLAY;
		}
	}
}

//ST_GAMEOVER
static	void	GameGameOver(EButtonState btn)
{
	if (isFirstLoop)
	{
		effectWait = 0;
	}
	
	//\1bԂ2_ł
	//E60msԊu16JEg1bo  4ĂяoɃgOB
	if (tci)
	{
		tci = 0;
		
		if (effectWait == 0)
		{
			//uGAME OVERv
			uint8_t grid = 1;
			VFD_GridArray(grid++, SegC_G, SegM_null);
			VFD_GridArray(grid++, SegC_A, SegM_null);
			VFD_GridArray(grid++, SegC_M, SegM_null);
			VFD_GridArray(grid++, SegC_E, SegM_null);
			VFD_GridArray(grid++, SegC_null, SegM_null);
			VFD_GridArray(grid++, SegC_O, SegM_null);
			VFD_GridArray(grid++, SegC_V, SegM_null);
			VFD_GridArray(grid++, SegC_E, SegM_null);
			VFD_GridArray(grid++, SegC_R, SegM_null);
		}
		
		if (effectWait == 4)
		{
			//
			for (uint8_t g = 1; g <= VFD_GRID_COUNT; g++)
			{
				VFD_GridArray(g, SegC_null, SegM_null);
			}
		}
		
		if (++effectWait == 8) { effectWait = 0; }
	}
	
	if (btn == ButtonOff)
	{
		cli();	//荞ݕs
		gameState = ST_SCORE;
	}
}

//ST_SCORE
static	void	GameScore(EButtonState btn)
{
	if (isFirstLoop)
	{
		uint8_t	grid = 1;
		uint8_t	buf[3];
		
		if (hiscore <= score)
		{
			hiscore = score;
			
			//uH.Score,999vƕ\
			VFD_GridArray(grid++, SegC_H, SegM_dp);
		}
		else
		{
			//u Score,999vƕ\
			VFD_GridArray(grid++, SegC_null, SegM_null);
		}
		
		VFD_GridArray(grid++, SegC_S, SegM_null);
		VFD_GridArray(grid++, SegC_c, SegM_null);
		VFD_GridArray(grid++, SegC_o, SegM_null);
		VFD_GridArray(grid++, SegC_r, SegM_null);
		VFD_GridArray(grid++, SegC_e, SegM_comma);
		
		ValueSplit(score, buf);
		VFD_GridArray(grid++, buf[0], SegM_null);
		VFD_GridArray(grid++, buf[1], SegM_null);
		VFD_GridArray(grid++, buf[2], SegM_null);
	}
	
	if (btn == ButtonOff)
	{
		gameState = ST_TITLE;
	}
}

//l1ɕi[ETvXj
static	void	ValueSplit(uint8_t n, uint8_t* buf)
{
	buf[0] = SegNums[n / 100];	n = n % 100;
	buf[1] = SegNums[n / 10];	n = n % 10;
	buf[2] = SegNums[n];
	
	if (buf[0] == SegNums[0])
	{
		buf[0] = SegC_null;
		if (buf[1] == SegNums[0])
		{
			buf[1] = SegC_null;
		}
	}
}
