//	wt]xH쎺	http://jsdiy.webcrow.jp
//	2021/05

#include <avr/io.h>
#include <util/delay.h>
#include "vfdctrl.h"


//VFDRg[1bitǂݍ܂(USCK:0->1)
#define	SEND_BIT	( (0 << USIWM1) | (1 << USIWM0) | (0 << USICS1) | (0 << USICS0) | (1 << USITC) )

//1bit𑗂o(USCK:1->0)
//ESPIIɂ́Ãobt@1bit荞ޓłB
#define	NEXT_BIT_READY	(SEND_BIT | (1 << USICLK))

//VFD 1́ASPI]obt@iTCYVFD_UpdateDatã}bsO\Č߂j
#define	TXBUF_LENGTH	3
static	uint8_t	txBuf[VFD_GRID_COUNT][TXBUF_LENGTH];

//_Ci~bNhCuɂ錻݂̌ʒui1`VFD_GRID_LENGTH̒lj
static	uint8_t	grid;

//֐
static	void	DataTransfer(uint8_t data);


//
void	VFD_Init(void)
{
	//|[gݒ
	USI_DDR		|=	(USI_DO | USI_USCK);	//o͕
	USI_PORT	&=	~(USI_DO | USI_USCK);	//Lo
	VFDC_DDR	|=	(VFDC_BLANK | VFDC_STROBE);		//o͕
	VFDC_PORT	&=	~(VFDC_BLANK | VFDC_STROBE);	//Lo
	
	VFD_DisplayOff();
	VFD_Clear();
	grid = 1;
}

//VFD
void	VFD_DisplayOff(void)
{
	VFDC_PORT |= VFDC_BLANK;
	
	//BLANK܂2000ns(Typ.)KvB
	//2000ns҂Ă΁ASTROBȆ҂Ԃƍ킹ď\҂ƂłB
	_delay_us(2);
}

//VFD_
void	VFD_DisplayOn(void)
{
	VFDC_PORT &= ~VFDC_BLANK;
}

//\e
void	VFD_Clear(void)
{
	for (uint8_t g = 1; g <= VFD_GRID_COUNT; g++) { VFD_GridArray(g, 0x00, 0x00); }
}

//w̌ɕZbg
//E̎̂ƂẮAw茅̕\e𑗐Mobt@ɃZbgB
/*
}bsOiVFDRg[[ICVFD̔z}猈܂j
HV-out	:x	x	x	x	20	19	18	17	16	15	14	13	12	11	10	9	8	7	6	5	4	3	2	1
VFD		:x	x	x	x	hlf	apo	cmm	dp	Sg	Sf	Se	Sd	Sc	Sb	Sa	G9	G8	G7	G6	G5	G4	G3	G2	G1
bit		:7	6	5	4	3	2	1	0	:7	6	5	4	3	2	1	0	:7	6	5	4	3	2	1	0
byte	:[2]							:[1]							:[0]
*/
void	VFD_GridArray(uint8_t grid, uint8_t segmentBits, uint8_t markBits)
{
	uint8_t* buf = txBuf[grid - 1];
	
	if (grid < 9)
	{
		buf[0] = (1 << (grid - 1));
		buf[1] = 0x00;
	}
	else
	{
		buf[0] = 0x00;
		buf[1] = (1 << (grid - 9));
	}
	
	buf[1] |= (segmentBits << 1);
	
	buf[2] = markBits;
}

//݂̃f[^eVFDɕ\
//EKxȎԊԊuŌĂяoB
void	VFD_DynamicDrive(void)
{
	//̌ֈړigrid=1`VFD_GRID_COUNTj
	if (++grid > VFD_GRID_COUNT) { grid = 1; }
	
	//Ώی̃f[^VtgWX^ɓ]
	//ESPI̓lAʃoCg瑗o邱ƂɒӁB
	uint8_t* buf = txBuf[grid - 1];
	for (int8_t i = TXBUF_LENGTH - 1; 0 <= i; i--) { DataTransfer(buf[i]); }
	
	//VFD
	VFD_DisplayOff();
	
	//ZOg̓_p^[XV
	VFDC_PORT |= VFDC_STROBE;
	_delay_us(0.2);		//100nsȏ
	VFDC_PORT &= ~VFDC_STROBE;
	
	//VFD_
	VFD_DisplayOn();
}

//f[^1byte]
/*
HV5812̎dlFF_clk <= 8MHz (T=25'C, 5V)
AVRUSI(SPI)̎dlFF_usck_max = F_sysclk / 2
F_usck_max <= F_data_in ł΁AHV5812Ńf[^̎肱ڂ͋NȂB
] F_sysclk <= 16MHz ł΁AUSĨrbgo̓m[EFCgok.
*/
static	void	DataTransfer(uint8_t data)
{
	USIDR = data;	//obt@Ƀf[^Zbg
	
	//xd̂ŁAfor()g킸x^
	USICR = SEND_BIT;		//MSBo(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)	cobt@1bit荞ޓłiSIzĂ΁j
	
	USICR = SEND_BIT;		//1bito(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)
	
	USICR = SEND_BIT;		//1bito(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)
	
	USICR = SEND_BIT;		//1bito(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)
	
	USICR = SEND_BIT;		//1bito(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)
	
	USICR = SEND_BIT;		//1bito(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)
	
	USICR = SEND_BIT;		//1bito(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)
	
	USICR = SEND_BIT;		//LSBo(USCK:0->1)
	USICR = NEXT_BIT_READY;	//̃rbg(USCK:1->0)
}
